healpix.essentials

## Class HealpixMapDouble

- java.lang.Object
- - healpix.essentials.HealpixTables
  - - healpix.essentials.HealpixBase
    - - healpix.essentials.HealpixMapDouble

All Implemented Interfaces:
  Serializable

    public class HealpixMapDouble
    extends HealpixBase

Class representing a full HEALPix map containing double values. This class is conceptually very similar the the Healpix_Map<double> class of Healpix_cxx.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class healpix.essentials.HealpixBase

`HealpixBase.Xyf`

### Field Summary

Fields
`static double` `undef`

### Fields inherited from class healpix.essentials.HealpixBase

`fact1, fact2, ncap, nl2, nl3, nl4, npface, npix, ns_max, nside, order, order_max, scheme`

### Fields inherited from class healpix.essentials.HealpixTables

`ctab, facearray, jpll, jrll, swap_cycle, swaparray, utab, xoffset, yoffset`

### Constructor Summary

Constructors
Constructor and Description
`HealpixMapDouble()`
`HealpixMapDouble(double[] data_in, Scheme scheme_in)`
`HealpixMapDouble(long nside_in, Scheme scheme_in)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `fill(double val)` Sets all map pixel to a specific value.
`double[]` `getData()` Returns the array containing all map pixels.
`double` `getPixel(int ipix)` Returns the value of the pixel with a given index.
`double` `getPixel(long ipix)` Returns the value of the pixel with a given index.
`void` `importDegrade(HealpixMapDouble orig, boolean pessimistic)` Imports the map "orig" to this object, adjusting pixel ordering and reducing resolution.
`void` `importGeneral(HealpixMapDouble orig, boolean pessimistic)` Imports the map "orig" to this object, adjusting pixel ordering and resolution if necessary.
`void` `importNograde(HealpixMapDouble orig)` Imports the map "orig" to this object, adjusting pixel ordering.
`void` `importUpgrade(HealpixMapDouble orig)` Imports the map "orig" to this object, adjusting pixel ordering and increasing resolution.
`void` `setDataAndScheme(double[] data_in, Scheme scheme_in)` Adjusts the object to scheme_in, and sets pixel data to data_in.
`void` `setNside(long nside_in)` Adjusts the object to nside_in.
`void` `setNsideAndScheme(long nside_in, Scheme scheme_in)` Adjusts the object to nside_in and scheme_in.
`void` `setPixel(int ipix, double val)` Sets the value of a specific pixel.
`void` `setPixel(long ipix, double val)` Sets the value of a specific pixel.
`void` `swapScheme()` Converts the map from NESTED to RING scheme or vice versa.

### Methods inherited from class healpix.essentials.HealpixBase

`ang2pix, boundaries, getNpix, getNside, getOrder, getScheme, loc2pix, maxPixrad, neighbours, nest2ring, npix2Nside, nside2Npix, nside2order, order2Npix, pix2ang, pix2loc, pix2ring, pix2vec, pix2xyf, pix2zphi, queryDisc, queryDiscInclusive, queryPolygon, queryPolygonInclusive, queryStrip, ring2nest, ring2theta, ring2xyf, ring2z, setScheme, vec2pix, xyf2pix, xyf2pix, zphi2pix`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### undef

    public static final double undef

See Also:
  Constant Field Values

### Constructor Detail

#### HealpixMapDouble

    public HealpixMapDouble()
                     throws Exception

Throws:
  `Exception`

#### HealpixMapDouble

    public HealpixMapDouble(long nside_in,
                            Scheme scheme_in)
                     throws Exception

Throws:
  `Exception`

#### HealpixMapDouble

    public HealpixMapDouble(double[] data_in,
                            Scheme scheme_in)
                     throws Exception

Throws:
  `Exception`

### Method Detail

#### setNside

    public void setNside(long nside_in)
                  throws Exception

Adjusts the object to nside_in.

Overrides:
  `setNside` in class `HealpixBase`
Parameters:
  `nside_in` - the new Nside parameter
Throws:
  `Exception`

#### setNsideAndScheme

    public void setNsideAndScheme(long nside_in,
                                  Scheme scheme_in)
                           throws Exception

Adjusts the object to nside_in and scheme_in.

Overrides:
  `setNsideAndScheme` in class `HealpixBase`
Parameters:
  `nside_in` - the new Nside parameter
  `scheme_in` - the new ordering scheme
Throws:
  `Exception`

#### setDataAndScheme

    public void setDataAndScheme(double[] data_in,
                                 Scheme scheme_in)
                          throws Exception

Adjusts the object to scheme_in, and sets pixel data to data_in.

Parameters:
  `data_in` - pixel data; must have a valid length (12*nside^2)
  `scheme_in` - the new ordering scheme
Throws:
  `Exception`

#### fill

    public void fill(double val)

Sets all map pixel to a specific value.

Parameters:
  `val` - pixel value to use

#### swapScheme

    public void swapScheme()
                    throws Exception

Converts the map from NESTED to RING scheme or vice versa. This operation is done in-place, i.e. it does not require additional memory.

Throws:
  `Exception`

#### getPixel

    public double getPixel(int ipix)

Returns the value of the pixel with a given index.

Parameters:
  `ipix` - index of the requested pixel
Returns:
  pixel value

#### getPixel

    public double getPixel(long ipix)

Returns the value of the pixel with a given index.

Parameters:
  `ipix` - index of the requested pixel
Returns:
  pixel value

#### setPixel

    public void setPixel(int ipix,
                         double val)

Sets the value of a specific pixel.

Parameters:
  `ipix` - index of the pixel
  `val` - new value for the pixel

#### setPixel

    public void setPixel(long ipix,
                         double val)

Sets the value of a specific pixel.

Parameters:
  `ipix` - index of the pixel
  `val` - new value for the pixel

#### getData

    public double[] getData()

Returns the array containing all map pixels.

Returns:
  the map array

#### importNograde

    public void importNograde(HealpixMapDouble orig)
                       throws Exception

Imports the map "orig" to this object, adjusting pixel ordering.

Parameters:
  `orig` - map to import
Throws:
  `Exception`

#### importUpgrade

    public void importUpgrade(HealpixMapDouble orig)
                       throws Exception

Imports the map "orig" to this object, adjusting pixel ordering and increasing resolution.

Parameters:
  `orig` - map to import
Throws:
  `Exception`

#### importDegrade

    public void importDegrade(HealpixMapDouble orig,
                              boolean pessimistic)
                       throws Exception

Imports the map "orig" to this object, adjusting pixel ordering and reducing resolution.

Parameters:
  `orig` - map to import
  `pessimistic` - if true, set a pixel to undefined if at least one the original subpixels was undefined; otherwise only set it to undefined if all original subpixels were undefined.
Throws:
  `Exception`

#### importGeneral

    public void importGeneral(HealpixMapDouble orig,
                              boolean pessimistic)
                       throws Exception

Imports the map "orig" to this object, adjusting pixel ordering and resolution if necessary.

Parameters:
  `orig` - map to import
  `pessimistic` - only used when resolution must be reduced: if true, set a pixel to undefined if at least one the original subpixels was undefined; otherwise only set it to undefined if all original subpixels were undefined.
Throws:
  `Exception`